/* 
officiel 22/06/17
ecrit pour l'arpschuino  www.arpschuino.fr/tuto_stepper.php
pilotage en DMX d'un moteur pas à pas, avec un driver. 

Adressage avec l'Arpdress board (avec I2CattinyDip_09_01_15)
pour que l'arpdress-board fonctionne, le port bas doit etre debranche.

Adressage avec l'Arpdress board :
2 clignotements brefs = l'adresse est prise depuis l'EEPROM.
1 cligotement jaune (arpdress board) et 1 vert =  l'adresse est prise depuis l'arpdress board et ÃƒÂ©crite dans l'EEPROM.
1 cligotement jaune (arpdress board) et 10 vert =  l'adresse est non conforme, l'adresse par defaut est prise.

Puis la led verte vibrillonne tant qu'elle recoit du DMX.

/////////////in english//////////////////////////

official 22/06/17
written for arpschuino  www.arpschuino.fr/tuto_stepper_e.php
DMX stepper control, with a driver. 

Addressing with arpdress board :
2 short flashes = the address is taken from the EEPROM.
1 yellow flash on the arpdress-board and 1 green flash = address is taken from the arpdress-board and written in EEPROM.
1 yellow flash on the arpdress-board and 10 green flashes =  the address is not compliant, the default address is taken.

Then the green led blink quiquely while the board receive DMX.

05_05_16 : fonctions dans un fichier separe
*/


# define nbr_tours 2
# define st_plus 3
# define dir 5
byte dmx_value=0;
byte dmx_speed; 
int nbr_pas=0;
boolean sens=0;
int previous;

#include "fonctions.h"

#include <lib_dmx.h>
#define default_adress (1)//adresse DMX par defaut
#define nbre_circuits (16)//
#define    DMX512     (0)  

int adress = default_adress;


void setup() {
//  pinMode (4, OUTPUT);
//  pinMode (st_plus, OUTPUT);
//  pinMode (dir, OUTPUT);
  DDRD = B00111010;
  PORTD |= B00010000;//eteind la led verte

  arpdress_board();//prise en charge de l'arpdress board
  //à commenter pour une adresse fixe  
///////////////////////////////////////////////////////////////////////
  ArduinoDmx0.attachRXInterrupt  (frame_received);
  ArduinoDmx0.set_control_pin(7);    // Arduino output pin for MAX485 input/output control (connect to MAX485 pins 2-3) 
  ArduinoDmx0.set_rx_address(adress);      // dmx start address
  ArduinoDmx0.set_rx_channels(nbre_circuits);     // number of rx channels
  ArduinoDmx0.init_rx(DMX512);        // starts universe 0 as rx, NEW Parameter DMX mode
  

}

void loop() {

  int val= map(dmx_value,0,255,0,8000*nbr_tours);//6400=1 tour
  nbr_pas=val - previous;
  previous = val;
  //direction////////////////////////  
  if(nbr_pas>0)
  {
    digitalWrite(dir,LOW);
  }
  else
  {
    //digitalWrite(dir,HIGH);
    PORTD |= B00100000;
  }
  ///vitesse/////////////////
  int vitesse = 400+10*dmx_speed ;
  /////tourne/////////////////
  int impulses;
  if (abs(nbr_pas)<=6400)
  {
    for (int i=0;i<abs(nbr_pas/2);i++)
    {
      //digitalWrite(st_plus,HIGH);
      PORTD |= B00001000;
      impulses=1000-i/5;
      delayMicroseconds(impulses);
      digitalWrite(st_plus,LOW);
      //PORTD &amp;= B11110111;
      delayMicroseconds(vitesse);
    }
    for (int i=0;i<abs(nbr_pas/2);i++)
    {
      //digitalWrite(st_plus,HIGH);
      PORTD |= B00001000;
      delayMicroseconds(impulses+i/5);
      digitalWrite(st_plus,LOW);
      //PORTD &amp = B11110111;
      delayMicroseconds(vitesse);
    }
  }

  else
  {
    for (int i=0;i<3200;i++)
    {
      //digitalWrite(st_plus,HIGH);
      PORTD |= B00001000;
      impulses=1000-i/5;
      delayMicroseconds(impulses);
      digitalWrite(st_plus,LOW);
      //PORTD &amp;= B11110111;
      delayMicroseconds(vitesse);
    }
    for (int i=0;i<abs(nbr_pas)-6400;i++)
    {
      //digitalWrite(st_plus,HIGH);
      PORTD |= B00001000;
      
      delayMicroseconds(impulses);
      digitalWrite(st_plus,LOW);
      //PORTD &amp;= B11110111;
      delayMicroseconds(vitesse);
    }    
    for (int i=0;i<3200;i++)
    {
      //digitalWrite(st_plus,HIGH);
      PORTD |= B00001000;
      delayMicroseconds(impulses+i/5);
      digitalWrite(st_plus,LOW);
      //PORTD &amp = B11110111;
      delayMicroseconds(vitesse);
    }    
  }
}

void frame_received(uint8_t universe) // cette boucle est executé à chaque réception d'une trame DMX
{
  led_temoin ();//la led clignote si elle reçoit un signal DMX  
  dmx_value = ArduinoDmx0.RxBuffer[0];
  dmx_speed = ArduinoDmx0.RxBuffer[1];
}


